-- TwitterPrinter - print tweets on a paper printer (client)
-- Copyleft 2015 Mastro Gippo
-- Released under the WTFPL ( http://www.wtfpl.net/txt/copying/ )
 
print('httpget.lua started')
Tstart  = tmr.now()
strpr = ""

function printe(stin)
	local j, ind = string.find(stin, "MGSTART")
	--print(string.sub(sin,100,300))
	
	conn = nil
	
	if ind == nil then
		--error?
		return
	end
	
	ind = ind+2
	strpr = string.sub(stin, ind)
	
	if string.byte(strpr,1) == 45 then
		--no news
		return 0
	end

	--printer on GPIO12
	gpio.write(6,gpio.HIGH)
	tmr.delay(500000) --500ms
	tmr.wdclr()
	gpio.write(6,gpio.LOW)
	tmr.delay(500000) --500ms
		
	for str in string.gmatch(strpr, "([^\r\n]+)") do
		tmr.wdclr()
		print(str)
		tmr.delay(500000) --500ms
	end
		
	--printer off GPIO13
	gpio.write(7,gpio.HIGH)
	tmr.delay(500000) --500ms
	tmr.wdclr()
	gpio.write(7,gpio.LOW)
	tmr.delay(500000) --500ms
	tmr.wdclr()
	
end

conn = nil
conn=net.createConnection(net.TCP, 0) 

-- show the retrieved web page

conn:on("receive", function(conn, payload) 
                       success = true
                       printe(payload) 
					   
						print("Sleeping!")
						--node.dsleep(300000000) --reset in 5 min
						--node.dsleep(10000000) --reset in 10 sec
						node.dsleep(600000000) --reset in 10 min
                       end) 

-- when connected, request page (send parameters to a script)
conn:on("connection", function(conn, payload) 
                       print('\nConnected') 
                       conn:send("GET /tweet.php?"
                        .."usr=ESP1"
                        .." HTTP/1.1\r\n" 
                        .."Host: www.mastrogippo.it\r\n" 
               		   .."Connection: close\r\n"
                        .."Accept: */*\r\n" 
                        .."User-Agent: Mozilla/4.0 (compatible; esp8266 Lua; Windows NT 5.1)\r\n" 
                        .."\r\n")
                       end) 
-- when disconnected, let it be known
conn:on("disconnection", function(conn, payload)
						print('\nDisconnected')
						end)

--init
gpio.write(6,gpio.LOW)
gpio.mode(6,gpio.OUTPUT)
gpio.write(6,gpio.LOW)
gpio.mode(7,gpio.OUTPUT)
gpio.write(7,gpio.LOW)

--printer off GPIO13
gpio.write(7,gpio.HIGH)
tmr.delay(500000) --500ms
tmr.wdclr()
gpio.write(7,gpio.LOW)
tmr.delay(500000) --500ms
tmr.wdclr()
	
print("Hello")
--uart.setup(0,19200,8,0,1,1)
conn:connect(80,'www.mastrogippo.it') 

